#include <fcntl.h>

#include <netdb.h>
#include <netinet/in.h>

#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/bio.h>

#include <pthread.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>

#ifndef __CLIENTS__
   #define __CLIENTS__ 10
#endif

#define SOCKET_ERROR        -1
#define BUFFER_SIZE         4096
#define MESSAGE             "This is the message I'm sending back and forth"
#define QUEUE_SIZE          5

/* Make these what you want for certificate & key files */
#define CERT_FILE "mycert.pem"
#define KEY_FILE  "mycert.pem"

/*Cipher list to be used*/
#define CIPHER_LIST "RC4-MD5"

/*Trusted CAs location*/
#define CA_FILE CERT_FILE
#define CA_DIR NULL

/*Password for the key file*/
#define KEY_PASSWD ""

#ifndef __CLEAR_SCREEN__
	#define __CLEAR_SCREEN__ "clear"
#endif

struct client
{
	int fd;
	struct sockaddr_in sockaddr;
	pthread_t thread;
	SSL * myssl;
	time_t last;
	struct client * next;
};

void * handler(void *);

void usage (void)
{
	puts("usage: ./server <PORT>\n\n");
	exit (-1);
}
