#include "server.h"

static void handle_request(int, struct sockaddr_in);

int main(int argc, char ** argv)
{
	// fd -> file descriptor
	int socket_server_fd    = (int)NULL,
		socket_server_port  = (int)NULL,
		socket_accept_fd    = (int)NULL,
		sockaddr_in_size    = sizeof(struct sockaddr_in),
		err                 = (int)NULL,
		pid					= (int)NULL;

	/* Internet socket address stuct */
	struct sockaddr_in server_addr,
					   accept_addr;

	bzero((char *) &server_addr, sockaddr_in_size);
	bzero((char *) &accept_addr, sockaddr_in_size);

	// make a socket
	socket_server_fd = socket(AF_INET, SOCK_STREAM, 0);
	if ( socket_server_fd == __SOCKET_ERROR__ )
	{
		fprintf(stderr, "\nCould not make a socket\n");
		exit(EXIT_FAILURE);
	}

	// fill address struct
	server_addr.sin_addr.s_addr = INADDR_ANY;
	server_addr.sin_port        = htons(8888);
	server_addr.sin_family      = AF_INET;
	bzero(&(server_addr.sin_zero), 8);

	// bind to a port
	if ( bind(socket_server_fd, (struct sockaddr *)&(server_addr), sizeof(server_addr)) == __SOCKET_ERROR__ )
	{
		fprintf(stderr, "\nCould not connect to host\n");
		exit(EXIT_FAILURE);
	}

	// get port number
	getsockname(socket_server_fd, (struct sockaddr *)&(server_addr), (socklen_t *) &(sockaddr_in_size));
	//if ( __DEBUG__  || verbose )
	//{
		printf("\nopened socket as fd (%d) on port (%d) for stream i/o\n", socket_server_fd, ntohs(server_addr.sin_port));

		printf("Server\n\
				sin_family        = %d\n\
				sin_addr.s_addr   = %d\n\
				sin_port          = %d\n"
				, server_addr.sin_family
				, server_addr.sin_addr.s_addr
				, ntohs(server_addr.sin_port)
			  );
		printf("\nMaking a listen queue of %d elements", __QUEUE_SIZE__);
	//}

	// establish listen queue
	if ( listen(socket_server_fd, __QUEUE_SIZE__) == __SOCKET_ERROR__ )
	{
		fprintf(stderr, "\nCould not listen\n");
		exit(EXIT_FAILURE);
	}

	while ( 1 )
	{
		//if ( __DEBUG__  || verbose )
			puts("\nWaiting for a connection\n");

		// get the connected socket
		socket_accept_fd = accept(socket_server_fd, (struct sockaddr *) &(accept_addr), (socklen_t *) &(sockaddr_in_size));

		if ( socket_accept_fd > -1 )
		{
			pid = fork();
			if ( pid )
			{
				close(socket_accept_fd);
				continue;
			}
			else
			{
				close(socket_server_fd);
				handle_request(socket_accept_fd, accept_addr);
				close(socket_accept_fd);
			}
			//close(socket_accept_fd);
		}
	}
}

static void handle_request(int sock, struct sockaddr_in client_addr)
{
	char * buffer_client;

	buffer_client = (char *) malloc(sizeof(char) * __BUFFER_SIZE__);
	bzero(buffer_client, __BUFFER_SIZE__);

	read(sock, buffer_client, __BUFFER_SIZE__);
	printf("%s\n", buffer_client);

	free(buffer_client);
}
