#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <stdarg.h>
#include <syslog.h>
#include <fcntl.h>
#include <semaphore.h>
#include <sys/ipc.h>
#include <sys/shm.h>

// Buffer size, in bytes, used for copying in the Cat() function.
const size_t BUF_SIZE = 4096;

// Global variables
char g_program_name[100];	// Initialised from argv[0] in ParseArgs()


// structs
struct client
{
	unsigned char * user;
	unsigned char * key;
	int jabber;
	int shmid;
	struct client * next,
				  * previous;
};

// Typedef for a signal handler function.
typedef void (* signal_handler_t) (int);

// Prototypes for functions in this file.
void ParseArgs (int, char **, struct in_addr *, unsigned short *, struct in_addr *, unsigned short *);
void Initialise (void);
void sig_child (int);
int CreateServerSocket (struct in_addr, unsigned short);
void Daemonise (void);
void MainLoop (int, struct in_addr, unsigned short);
void Proxy (int, int);
int AcceptClientConnection (int);
int ConnectToServer (struct in_addr, unsigned short);
void Cat (int, int);
int NameToAddr (const char *, struct in_addr *);
int NameToPort (const char *, unsigned short *, const char *);
#ifdef __GNUC__
	void quit (const char *, ...) __attribute__ ((format (printf, 1, 2)));
	void pbomb (const char *, ...) __attribute__ ((format (printf, 1, 2)));
	void hbomb (const char *, ...) __attribute__ ((format (printf, 1, 2)));
#else
	void quit (const char *, ...);
	void pbomb (const char *, ...);
	void hbomb (const char *, ...);
#endif
void set_signal_handler (int, signal_handler_t);
